apeman-wch
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]

[bd_repo_url]: https://github.com/apeman-cmd-labo/apeman-wch
[bd_travis_url]: http://travis-ci.org/apeman-cmd-labo/apeman-wch
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-cmd-labo/apeman-wch.svg?style=flat
[bd_license_url]: https://github.com/apeman-cmd-labo/apeman-wch/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-cmd-labo/apeman-wch
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-cmd-labo/apeman-wch.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-cmd-labo/apeman-wch.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-cmd-labo/apeman-wch
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-cmd-labo/apeman-wch.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-wch
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-wch.svg?style=flat
[bd_bower_badge_url]: https://img.shields.io/bower/v/apeman-wch.svg?style=flat

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

File watcher for apeman.

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>



<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/readme/01.Installation.md.hbs" Start -->

<a name="section-doc-readme-01-installation-md"></a>
Installation
-----

Install apeman-wch module via [npm][npm_url].
```bash
$ npm install apeman-wch -g
```


[npm_url]: https://www.npmjs.com/

<!-- Section from "doc/readme/01.Installation.md.hbs" End -->

<!-- Section from "doc/readme/02.Usage.md.hbs" Start -->

<a name="section-doc-readme-02-usage-md"></a>
Usage
---------

1. Prepare an Apemanfile.js at your project root.
2. Run the command via CLI.

***Apemanfile.js***
```javascript
/** Example of Apemanfile.js */

"use strict";

module.exports = {
    $cwd: __dirname,
    $pkg: {/*...*/},
    $tmpls: {/*...*/},
    $tasks: {/*...*/},
    $apps: {/*...*/},
    $wchs: {
        'scss-to-compile': {
            // Files to watch
            pattern: 'src/**/*.scss',
            // Callback when file changed.
            action: function () {
                require('apeman').task('compile:scss');
            }
        }
    }
};
```

Then,

```bash
$ apeman-wch "scss-to-compile"
```


##### CLI Options

```bash
$ apeman-wch -h

  Usage: apeman-wch [options] [name...] 

  Watch files to trigger action.

  Options:

    -h, --help                           output usage information
    -V, --version                        output the version number
    -v, --verbose                        Show verbose logs
    -c, --configuration <configuration>  Pathname of Apemanfile
    -t, --interval <interval>            Milliseconds of interval to run action.

  Examples:

    $ apeman-watch                     # List available watches
    $ apeman-watch myWatch01           # Start watching.


```


<!-- Section from "doc/readme/02.Usage.md.hbs" End -->

<!-- Section from "doc/readme/03.Programmatic API.md.hbs" Start -->

<a name="section-doc-readme-03-programmatic-a-p-i-md"></a>
Programmatic API
---

apeman-wch also provide programmatic API.

Firstly, install the module locally.

```bash
$ npm install apeman-wch --save-dev
```

Then,

```javascript
var apemanWch = require('apeman-wch');

apemanWch('scss-to-compile',{

}, function(err){
    /*...*/
});
```


##### Programmatic Options

| Key | Description | Default |
| --- | ----------- | ------- |
| verbose | Show verbose logs |  |
| configuration | Pathname of Apemanfile |  |
| interval | Milliseconds of interval to run action. | 300 |


<!-- Section from "doc/readme/03.Programmatic API.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-cmd-labo/apeman-wch/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman](http://github.com/apeman-labo/apeman)
+ [apeman-cmd-labo](http://github.com/apeman-cmd-labo)

<!-- Links End -->
