"use strict";

var argx = require('argx'),
    arrayreduce = require('arrayreduce'),
    arrayfilter = require('arrayfilter'),
    apemanfile = require('apemanfile'),
    async = require('async'),
    runWatch = require('./watching/run_watch'),
    listWatchs = require('./watching/list_watches');

/** @lends apemanWch */
function apemanWch(name, options, callback) {
    var args = argx(arguments);
    callback = args.pop('function') || argx.noop;
    options = args.pop('object') || {};
    name = args.remain().reduce(arrayreduce.arrayConcat(), []).filter(arrayfilter.emptyReject());
    async.waterfall([
        function (callback) {
            apemanfile.load(options.configuration, callback);
        },
        function (apemanfile, callback) {
            var here = process.cwd(),
                cwd = apemanfile.$cwd || process.cwd();
            async.series([
                function (callback) {
                    process.chdir(cwd);
                    callback(null);
                },
                function (callback) {
                    if (name.length > 0) {
                        runWatch(apemanfile, name, {
                            interval:options.interval
                        }, callback);
                    } else {
                        listWatchs(apemanfile, callback);
                    }
                },
                function (callback) {
                    process.chdir(here);
                    callback(null);
                }
            ], function (err, results) {
                callback(err, results[1])
            });
        }
    ], callback);
}

module.exports = apemanWch;
