/**
 * Logger for run.
 * @memberof module:apeman-wch/lib/logging
 * @constructor RunLogger
 * @returns A logger instance.
 */

"use strict";

var colorprint = require('colorprint');

/** @lends RunLogger */
module.exports = colorprint.define(
    /** @lends RunLogger.prototype */
    {
        logWatchStarting: function (name) {
            var s = this;
            s.notice('Starting watching "%s" ...', [].concat(name).join(','));
            return s;
        },
        logWatchStarted: function () {
            var s = this;
            s.notice('... watching get started.');
            return s;
        },
        logWatchFailed: function (err) {
            var s = this;
            s.fatal('Failed to watch: %s', err && err.stack || err);
            return s;
        }
    }
);
